execbase:	equ	4
findresident:	equ	-$60
doio:		equ	-$1c8
location:	equ	$50000
org location
load location

dc.b	"DOS",0
dc.l	$0
dc.l	$370
start:
	move.w	#$8100,$dff096
	move.l	#location,a2
	lea.l	blocklong(pc),a3
	move.l	(a3),d1
	move.l	#0,a3
	move.l	#0,d2
checkloop:
	bclr	d2,d1
	bne	loadthis
	add.l	#$0200,a3
	addq.l	#1,d2
	tst.l	d1
	bne	checkloop
	bra	fertig_geladen
loadthis:
	move.l	execbase,a6
	move.w	#2,28(a1)
	move.l	a3,44(a1)
	move.l	a2,40(a1)
	move.l	#$0200,36(a1)
	movem.l	d1-d2/a1-a3,-(a7)
	jsr	doio(a6)
	movem.l	(a7)+,d1-d2/a1-a3
	add.l	#$0200,a3
	add.l	#$0200,a2
	addq.l	#1,d2
	tst.l	d0
	beq	checkloop
	bra	continue_boot
fertig_geladen:
	jsr	begin
continue_boot:
	move.l	execbase,a6
	lea	dosname(pc),a1
	jsr	findresident(a6)
	tst.l	d0
	beq	boot_failed
	move.l	d0,a0
	move.l	22(a0),a0
	moveq	#0,d0
	rts
boot_failed:
	moveq	#1,d0
	rts
dosname:	dc.b	"dos.library",0
blocklong:	dc.l	$00000001
		even
begin:
;   ----------------------------------------------
;   - BOOTMENUE BY THE GREAT MEGAFORCE (HOLLAND) -
;   ----------------------------------------------

	bra.s	beginhereandnowhereelse
	even
beginhereandnowhereelse:
	bsr.L	decruncher
	clr.w	color1+6
	clr.w	color2+6
	clr.w	color3+6
	clr.w	color4+6
	clr.w	color5+6
	clr.w	color6+6
	clr.w	color7+6
	clr.w	color8+6
	clr.w	color9+6
	clr.w	color8b+10
	clr.w	color7b+6
	clr.w	color6b+6
	clr.w	color5b+6
	clr.w	color4b+6
	clr.w	color3b+6
	clr.w	color2b+6
	clr.w	color1b+6

	move.l $4,a6
	lea gfxname,a1
	jsr -408(a6)		;OldOpenLibrary (a1)
	move.l d0,gfxbase
	move.l d0,a6
	move.l 50(a6),copsave
	move.l #copperl,50(a6)
	lea rastport,a1
	jsr -198(a6)		;InitRastport (a1)
	move.l #bitmap,rastport+4
	move.l #$60000,a1
loop1:	clr.l (a1)+
	cmp.l #$63000,a1
	bls.S loop1

	move.l	gfxbase,a6
	move.l	#9,count
	move.l	#$7,posy
	move.l	#text-17,textpointer
textprint:	lea rastport,a1
	clr.l 	d0
	addq.l	#8,posy
	move.l	posy,d1
	jsr	-240(a6)		;Move (a1,d0/d1)
	lea	rastport,a1
	add.l	#15,textpointer
	move.l	textpointer,a0
	move.l	#15,d0
	jsr	-60(a6)		;Text (a1,a0,d0)
	lea	rastport,a1
	add.l	#15,textpointer
	move.l	textpointer,a0
	move.l	#15,d0
	jsr	-60(a6)
	subq.l	#1,count
	bne.s	textprint

	clr.l	d2
	move.l	#$00010000,d0
wait2:	subq.l	#1,d0
	bne.s	wait2
	move.w	#$002,d2
	bsr.s	fade1
	bsr.s	fade2
	bsr.L	fade3
	bsr.L	fade4
	move.w	#$222,d2
	bsr.L	fade5
	bsr.L	fade6
	bsr.L	fade7
	move.w	#$221,d2
	bsr.L	fade8
	move.w	#$aaf,color9+6

keytest:
	btst	#0,$bfec01	;keytest
	beq.l	keytest
	move.b	$bfec01,d2	;read key
	andi.b	#$fe,d2
	lea	keymap,a0
keysearch:
	move.b	(a0)+,d0
	tst.b	d0
	beq.l	keytest
	cmp.b	d0,d2		;only one of those keys
	bne.s	keysearch
	move.b	d0,$24

	move.l a6,a0
	move.l copsave,50(a0)
	move.l $4,a6
	move.l gfxbase,a1
	jsr -414(a6)
	rts

fade1:	addq.b	#2,color1+7
	addq.b	#2,color1b+7
fade2:	addq.b	#2,color2+7
	addq.b	#2,color2b+7
fade3:	addq.b	#2,color3+7
	addq.b	#2,color3b+7
fade4:	addq.b	#2,color4+7
	addq.b	#2,color4b+7
fade5:	add.w	d2,color5+6
	add.w	d2,color5b+6
fade6:	add.w	d2,color6+6
	add.w	d2,color6b+6
fade7:	add.w	d2,color7+6
	add.w	d2,color7b+6
fade8:	add.w	d2,color8+6
	add.w	d2,color8b+10
fade9:	add.w	d2,color9+6
	move.l	#$00004000,d0
wait1:	subq.l	#1,d0
	bne.s	wait1
	rts

decruncher:
s:
	lea end(pc),a0
	lea $70000,a1		
	move.l -(a0),a2		
	add.l a1,a2		
	move.l -(a0),d5		
	move.l -(a0),d0		
	eor.l d0,d5		

notfinished:
	lsr.l #1,d0
	bne.S notempty1
	bsr.L getnextlwd
	notempty1:
	bcs.S bigone		

	moveq #8,d1	
	moveq #1,d3	
	lsr.l #1,d0
	bne.S notempty2
	bsr.S getnextlwd
notempty2:
	bcs.S dodupl	

	moveq #3,d1	
	clr.w d4	

dojmp:		
			
	bsr.S rdd1bits	
	move.w d2,d3	
	add.w d4,d3	

getd3chr:

	moveq #7,d1	
get8bits:
	lsr.l #1,d0
	bne.S notempty3
	bsr.S getnextlwd
notempty3:
	roxl.l #1,d2
	dbf d1,get8bits	

	move.b d2,-(a2)
	dbf d3,getd3chr	
	bra.S nextcmd

bigjmp:
	moveq #8,d1	
	moveq #8,d4	
		
		
		
	bra.S dojmp

bigone:
	moveq #2,d1	
	bsr.S rdd1bits
	cmp.b #2,d2	
	blt.S midjumps	
	cmp.b #3,d2	
	beq.S bigjmp	


	moveq #8,d1	
	bsr.S rdd1bits	
	move.w d2,d3	
	move.w #12,d1	
	bra.S dodupl	

midjumps:
	move.w #9,d1	
	add.w d2,d1
	addq #2,d2
	move.w d2,d3	

dodupl:
	bsr.S rdd1bits	
		
		
copyd3bytes:
	subq #1,a2

	move.b (a2,d2.w),(a2)

	dbf d3,copyd3bytes

nextcmd:
	cmp.l a2,a1
	blt.L notfinished
	tst.l d5
	bne.S damage
	rts

damage:
	move.w #$ffffffff,d0
damloop:
	move.w d0,$dff180
	subi.l #1,d0
	bne.S damloop
	rts


getnextlwd:
	move.l -(a0),d0
	eor.l d0,d5
	move.w #$10,ccr
	roxr.l #1,d0
	rts

rdd1bits:	
	subq.w #1,d1
	clr.w d2

getbits:
	lsr.l #1,d0
	bne.S notempty
	move.l -(a0),d0
	eor.l d0,d5
	move.w #$10,ccr
	roxr.l #1,d0

notempty:
	roxl.l #1,d2
	dbf d1,getbits
	rts
prog:	incbin	"prog"
	;dcb.b $1280,0
end:

keymap: dc.b $be,$94,$98,$ba,$da,$b8,$b6,$b4,$d0,0
nottext: dc.b '  '
text:	;     1234567890123456789012345678901234567890
	dc.b 'A = X-COPY (CRACKED BY MFC)   '
	dc.b 'B = CLI-MATE V1.2 (UPDATE)    '
	dc.b 'C = FAST-LIGHTNING (ERRORF.)  '
	dc.b 'D = WHITE-LIGHTNING           '
	dc.b 'E = H.Q.C.-CRUNCHER           '
	dc.b 'F = MARAUDER II (010 BRAIN.)  '
	dc.b 'G = CV-PARAMETER COPY         '
	dc.b 'H = PROJECT-D (NEW PARAM.)    '
	dc.b 'I = A-COPIER V1.3 (83 TR.)    '

	even
gfxname:	dc.b 'graphics.library',0,0
gfxbase:	dcb.l 1,0
copsave:	dcb.l 1,0
copperl:
	 dc.w $0111,$fffe
	dc.l	$01800000,$01820eee,$01840ddd,$01860ccc
	dc.l	$01880aaa,$018a0999,$018c0888,$018e0777
	dc.l	$01900666,$01920555,$01940444,$01960333
	dc.l	$01980ddf,$019a0ccf,$019c0bbf,$019e0aaf
	dc.l	$01a0099f,$01a2088f,$01a4077f,$01a6066f
	dc.l	$01a8055e,$01aa0d00,$01ac0008,$01ae0007
	dc.l	$01b00006,$01b20005,$01b40004,$01b6044d
	dc.l	$01b8033c,$01ba022b,$01bc0222,$01be0111
	 dc.w $0120,$0000
	 dc.w $0122,$00c0
	 dc.w $008e,$2c71
	 dc.w $0100,$0200
	 dc.w $0104,$0000
	 dc.w $0090,$2ad1
	 dc.w $0092,$0030
	 dc.w $0094,$00d8
	 dc.w $0102,$0000
	 dc.w $0108,$0000
	 dc.w $010a,$0000
	dc.l	$00e00007,$00e20000,$00e40007,$00e60ef4
	dc.l	$00e80007,$00ea1de8,$00ec0007,$00ee2cdc
	dc.l	$00f00007,$00f23bd0
	 dc.w $3601,$fffe
	 dc.w $0100,$5200
	dc.l	$01800d00
	dc.l	$3711fffe,$01800000
	dc.l	$6c11fffe,$01800004
	dc.l	$6d11fffe,$01800005
	dc.l	$6e11fffe,$01800006
	dc.l	$6f11fffe,$01800007
	dc.l	$7011fffe,$01800008
	dc.l	$8c11fffe,$01800d00
	 dc.w $8d01,$fffe
	dc.l	$01800000
	 dc.w $0100,$0200
		dc.w $008e,$90d1
		dc.w $0090,$2071
		dc.w $0092,$0060
		dc.w $0094,$00a8
		dc.w $0102,$0000
		dc.w $0104,$0000
		dc.w $0108,$0002
		dc.w $010a,$0002
		dc.w $00e0,$0006
		dc.w $00e2,$0000
		dc.w $0182,$0000
color1:	dc.w $9601,$ff00,$0180,$0000
color2:	dc.w $9701,$ff00,$0180,$0000
color3:	dc.w $9801,$ff00,$0180,$0000
color4:	dc.w $9901,$ff00,$0180,$0000,$0100,$9200
color5:	dc.w $9a01,$ff00,$0180,$0000
color6:	dc.w $9b01,$ff00,$0180,$0000
color7:	dc.w $9c01,$ff00,$0180,$0000
color8:	dc.w $9d01,$ff00,$0180,$0000
color9:	dc.w $9e01,$ff00,$0180,$0000

color8b:	dc.w $ed01,$ff00,$0100,$0200,$0180,$0000
color7b:	dc.w $ee01,$ff00,$0180,$0000
color6b:	dc.w $ef01,$ff00,$0180,$0000
color5b:	dc.w $f001,$ff00,$0180,$0000
color4b:	dc.w $f101,$ff00,$0180,$0000
color3b:	dc.w $f201,$ff00,$0180,$0000
color2b:	dc.w $f301,$ff00,$0180,$0000
color1b:	dc.w $f401,$ff00,$0180,$0000
	dc.w $f501,$ff00,$0180,$000
	dc.w $ffff,$fffe
NULL = 0
JAM1       = 0
FRSTDOT     = 1
ONE_DOT     = 2
AREAOUTLINE = 8
AreaInfo:
ai_VctrTbl:   dc.l ; pointer naar start vectortabel
ai_VctrPtr:   dc.l ; pointer naar huidige vertex
ai_FlagTbl:   dc.b ; pointer vector flag-tabel
ai_FlagPtr:   dc.b ; 
ai_Count:     dc.w NULL
ai_MaxCount:  dc.w NULL
ai_FirstX:    dc.w NULL
ai_FirstY:    dc.w NULL
ai_SIZEOF:  ; label

RastPort: ;				rastport
rp_Layer:     dc.l NULL 
rp_BitMap:    dc.l BitMap
rp_AreaPtrn:  dc.l NULL ; pointer naar fillpattern
rp_TmpRas:    dc.l NULL
rp_AreaInfo:  dc.l AreaInfo
rp_GelsInfo:  dc.l NULL
rp_Mask:      dc.b 255
rp_FgPen:     dc.b 1 ;		voorgrond-pen
rp_BgPen:     dc.b 0 ;		achtergrond-pen
rp_AOLPen:    dc.b 2 ;		(areafill-outline-pen)
rp_DrawMode:  dc.b JAM1
rp_AreaPtSz:  dc.b NULL ; 2^n woorden voor area-fill
rp_Dummy:     dc.b NULL
rp_linpatcnt: dc.b 0 ; huidig lijn-pattern voor-verschuiving
rp_Flags:     dc.w FRSTDOT + ONE_DOT + AREAOUTLINE
rp_LinePtrn:  dc.w %1111111111111111 ; line-pattern
rp_cp_x:      dc.w 0 ;| pen-
rp_cp_y:      dc.w 0 ;| positie
rp_minterms:  dcb.b 8,0
rp_PenWidth:  dc.w 1
rp_PenHeight: dc.w 1
rp_Font:      dc.l NULL ; pointer naar karakterset
rp_AlgoStyle: dc.b NULL ; berekende stijl
rp_TxFlags:   dc.b NULL ; textspecifieke flags
rp_TxHeight:  dc.w 8
rp_TxWidth:   dc.w 8
rp_TxBaseline:   dc.w 0
rp_TxSpacing:    dc.w 8
rp_RP_User:      dc.l NULL ; adres gebruiker
rp_wordreserved: dcb.w 7,0  ;|   voor
rp_longreserved: dcb.l 2,0  ;| toekomstig
rp_reserved:     dcb.b 8,0  ;|  gebruik
rp_SIZEOF:

BitMap: ;			karakterset
 dc.w 42
  dc.w 200
  dc.b 0
  dc.b 1
  dc.w 0
  dc.l $60000,0,0,0,0,0

count: dc.l 0
posy: dc.l 0
textpointer: dc.l 0

finis:

